(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA        LRI-CNRS        ENS-CNRS                *)
(*              Rocquencourt         Orsay          Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.3                                 *)
(*                               July 1st 1999                              *)
(*                                                                          *)
(****************************************************************************)
(*                              metasyntax.mli                              *)
(****************************************************************************)

open Extend

(* Adding grammar and pretty-printing objects in the environment *)

val add_syntax_obj : string -> CoqAst.t list -> unit

val add_grammar_obj : string -> CoqAst.t list -> unit
val add_token_obj : string -> unit

val add_infix : Gramext.g_assoc option -> int -> string -> string -> unit
val add_distfix : Gramext.g_assoc option -> int -> string -> string -> unit

val print_grammar : string -> string -> unit

(* $Id: metasyntax.mli,v 1.7 1999/06/29 07:47:05 loiseleu Exp $ *)
