
open List;;
open Std;;
open Initial;;
open Names;;
open Term;;
open Generic;;
open Mach;;
open Tacmach;;
open Pfedit;;
open Pretty;;
open Clexer;;
open Parsing;;
open Himsg;;
open More_util;; 
open Pp;;
open Libobject;;


open Library;;
open Libobject;;
open Environ;;
open Termenv;;
open States;;
open Trad;;
open Ast;;
open Vernacinterp;;
open Termast;;
open Machops;;
open Classops;;
open Recordops;;


(*****  object definition ******)
 
let typ_lams_of t = 
let rec aux acc = function
   DOP2(Lambda,c1,DLAM(x,c2)) -> aux (c1::acc) c2
  | (DOP2(Cast,c,_)) -> aux acc c
  | t -> acc,t
in aux [] t
;;

let objdef_err id = errorlabstrm "object_declare"
                              [< 'sTR(string_of_id id); 'sTR" is not a structure object" >];;


let trait t id = 
  match (collapse_appl t) with
    DOPN(AppL,v) -> if (match v.(0) with  
                         (DOPN(Const _,_)|DOPN(MutInd _,_)|
                          VAR _|DOPN(MutConstruct _,_)) -> true    
                      | _ -> false)
                    then (v.(0),tl(Array.to_list v))
                    else raise Not_found
   | (DOPN(Const _,_)|DOPN(MutInd _,_)|
      VAR _|DOPN(MutConstruct _,_)) -> t,[]
  | _ -> raise Not_found
;;

let objdef_declare id = 
 let (sigma,sign) = initial_sigma_sign() in
let v = global (gLOB(initial_sign())) id in
let sp,c',vc = match (strip_outer_cast v) with
 (DOPN(Const sp,l) as c') -> (try sp,c',const_value sigma c'
                             with _ -> objdef_err id) 
 | _ -> objdef_err id in
let lt,t = typ_lams_of vc in
match t with 
 DOPN(AppL,v) -> let {s_PARAM=p;s_PROJ=lpj}= 
                        (try (struc_info (match v.(0) with
                                            (DOPN(MutConstruct ((sp,0),1),_)) -> sp
                                          | _ -> objdef_err id))
                       with _ -> objdef_err id) in
                let l = Array.to_list v in
                let x,projs = (try chop_list (p+1) l
                               with _ -> objdef_err id) in
                let params = tl x in
                let lps = (try List.combine lpj projs 
                       with _ -> objdef_err id) in
                let comp = List.fold_left (fun l (spopt,t) -> (* comp=components *)
                                          match spopt with None -> l
                                                     | Some sp -> try (sp,(trait t id))::l
                                                                  with Not_found -> l)
                                     [] lps in
                add_anonymous_object (inObjDef1 sp);
                List.iter (fun (spi,(ci,l_ui)) -> 
                        add_new_objdef ((NAM_SP spi,cte_of_constr ci),c',rev lt,params,l_ui)) comp
 | _ -> objdef_err id
;;
                 
