(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA        LRI-CNRS        ENS-CNRS                *)
(*              Rocquencourt         Orsay          Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.3                                 *)
(*                               July 1st 1999                              *)
(*                                                                          *)
(****************************************************************************)
(*                               variables.ml                               *)
(****************************************************************************)

open Std;;
open Names;;
open Vectops;;
open Term;;
open Pp;;
open Mach;;

let infexecute_variable psign name t =
  let evd = Evd.mt_evd() in
  let sp = Lib.make_path OBJ name in
  let (u,(tj,inf)) = infexecute_type_with_univ evd psign sp t in
  let fty = (match inf with
                 Logic -> None
               | Inf infj -> Some(outjudge_type infj))
  in (u,(tj,fty))
;;

(* $Id: variables.ml,v 1.12 1999/08/06 20:49:09 herbelin Exp $ *)
