(**************************************************************************
  *********                    ntsons.mli                         *********
  **************************************************************************)
open Ntdef;;

(*nc_sons *)
val nc_lambda_son : natural_constr -> natural_constr;;

val nc_apply_subs : natural_constr -> natural_constr list;;

val nc_apply_head : natural_constr -> natural_constr;;

val nc_elim_cases : natural_constr -> natural_constr list;;

val nc_elim_head : natural_constr -> natural_constr;;

val nc_elim_one_case : natural_constr -> natural_constr;;

val nc_fix_sons : natural_constr -> natural_constr list;;

val nc_sons : natural_constr -> natural_constr list;;

(*nc_sons *)
val nc_lambda_son_fun :
      natural_constr -> (natural_constr -> natural_constr) * natural_constr;;

val nc_apply_subs_fun :
      natural_constr -> (natural_constr list -> natural_constr) *
                        natural_constr list;;

val nc_apply_head_fun :
      natural_constr -> (natural_constr -> natural_constr) * natural_constr;;

val nc_elim_cases_fun :
      natural_constr -> (natural_constr list -> natural_constr) *
                        natural_constr list;;

val nc_elim_head_fun :
      natural_constr -> (natural_constr -> natural_constr) * natural_constr;;

val nc_elim_one_case_fun :
      natural_constr -> (natural_constr -> natural_constr) * natural_constr;;

val nc_fix_sons_fun :
      natural_constr -> (natural_constr list -> natural_constr) *
                        natural_constr list;;

val nc_sons_fun :
      natural_constr -> (natural_constr list -> natural_constr) *
                        natural_constr list;;

(*nc_rec_sons *)
val nc_rec_apply_subs : natural_constr -> natural_constr list;;

val nc_rec_elim_cases : natural_constr -> natural_constr list;;

val nc_rec_elim_one_case : natural_constr -> natural_constr;;

val nc_rec_sons : natural_constr -> natural_constr list;;

(*global functions *)
val nc_do_to_sons : (natural_constr -> unit) -> natural_constr -> unit;;

val nc_do_top_down : (natural_constr -> 'a) -> natural_constr -> unit;;

val nc_do_down_top : (natural_constr -> 'a) -> natural_constr -> unit;;

val nc_app_to_sons :
      (natural_constr -> natural_constr) -> natural_constr -> natural_constr;;

val nc_app_top_down :
      (natural_constr -> natural_constr) -> natural_constr -> natural_constr;;

val nc_app_down_top :
      (natural_constr -> natural_constr) -> natural_constr -> natural_constr;;

