(**************************************************************************
  *********                     tutil.mli                         *********
  **************************************************************************)
open Names;;
open Generic;;
open Term;;

val apply_to_oper : ('a -> 'a) -> 'a term -> 'a term;;

val map_oper : ('a -> 'b) -> 'a term -> 'b term;;

val apply_to_sons : ('a term -> 'a term) -> 'a term -> 'a term;;

val apply_top_down : ('a term -> 'a term) -> 'a term -> 'a term;;

val apply_down_top : ('a term -> 'a term) -> 'a term -> 'a term;;

val do_to_sons : ('a term -> unit) -> 'a term -> unit;;

val do_top_down : ('a term -> 'b) -> 'a term -> unit;;

val do_down_top : ('a term -> 'b) -> 'a term -> unit;;

val def_id : identifier;;

val f_R_to_V : identifier list -> 'a term -> 'a term;;

val f_V_to_R : identifier list -> 'a term -> 'a term;;

val from_Rel_to_VAR : 'a term -> 'a term;;

val from_VAR_to_Rel : 'a term -> 'a term;;

val apply_head : constr -> constr;;

val count_prod : constr -> int;;

val strip_outer_app_cast : constr -> constr;;

val select_list_of_vect : ('a -> bool) -> 'a array -> 'a list;;

val select_list_fisrt : ('a -> bool) -> 'a list -> 'a;;

val select_vect_first : ('a -> bool) -> 'a array -> 'a;;

val flat_map_list_of_vect : ('a -> 'a list) -> 'a array -> 'a list;;

